/*
 *         
 * SmoothAlgorithms.mqh
 *   (): MetaTrader\\MQL5\Include
 */
//+------------------------------------------------------------------+
//|                                                3XMA_Ishimoku.mq5 | 
//|                               Copyright  2011, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2011, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
#property description "3Ishimoku XMA"
//----   
#property version   "1.01"
//----     
#property indicator_chart_window 
//----    3
#property indicator_buffers 3 
//----   3  
#property indicator_plots   2
//+-----------------------------------+ 
//|                 |
//+-----------------------------------+
#define RESET 0 //        
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1 Blue
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "Ishimoku XMA"

//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type2   DRAW_FILLING
//----      
#property indicator_color2 Lime,Red
//----   
#property indicator_label1  "Ishimoku Cloud"

//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum MODE_PRICE // 
  {
   OPEN = 0,     //  
   LOW,          // 
   HIGH,         // 
   CLOSE         //  
  };
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint Up_period1=3; //1 ,      
input uint Dn_period1=3; //1 ,      
//----
input uint Up_period2=6; //2 ,      
input uint Dn_period2=6; //2 ,      
//----
input uint Up_period3=9; //3 ,      
input uint Dn_period3=9; //3 ,      
//---- 
input MODE_PRICE Up_mode1=HIGH;  //1     
input MODE_PRICE Dn_mode1=LOW;   //1     
//---- 
input MODE_PRICE Up_mode2=HIGH;  //2     
input MODE_PRICE Dn_mode2=LOW;   //2     
//---- 
input MODE_PRICE Up_mode3=HIGH;  //3     
input MODE_PRICE Dn_mode3=LOW;   //3     
//---- 
input Smooth_Method XMA1_Method=MODE_SMA; //1  
input Smooth_Method XMA2_Method=MODE_SMA; //2  
input Smooth_Method XMA3_Method=MODE_SMA; //3  
//----
input int XLength1=8; //1   
input int XLength2=25; //2  
input int XLength3=80; //3  
//----                  
input int XPhase=15; // ,
                     // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
//---- 
input int Shift1=0; //   1    
input int Shift2=0; //   2    
input int Shift3=0; //   3    
//+-----------------------------------+

//----   ,    
//      
double XMA1[],XMA2[],XMA3[];

//----      
int StartBars;
//----      
int XMA1_Handle,XMA2_Handle,XMA3_Handle;
//+------------------------------------------------------------------+   
//| 3 Ishimoku XMA indicator initialization function                 | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----    CXMA   SmoothAlgorithms.mqh
   CXMA XMA;
//----     
   int StartBars1=int(MathMax(Up_period1,Dn_period1));
   StartBars1+=XMA.GetStartBars(XMA1_Method,XLength1,XPhase);
   int StartBars2=int(MathMax(Up_period2,Dn_period2));
   StartBars1+=XMA.GetStartBars(XMA2_Method,XLength2,XPhase);
   int StartBars3=int(MathMax(Up_period3,Dn_period3));
   StartBars3+=XMA.GetStartBars(XMA3_Method,XLength3,XPhase);
   StartBars=MathMax(StartBars1,MathMax(StartBars2,StartBars3));
   
//----    XMA_Ishimoku 1
   XMA1_Handle=iCustom(Symbol(),PERIOD_CURRENT,"XMA_Ishimoku",
                  Up_period1,Dn_period1,Up_mode1,Dn_mode1,XMA1_Method,XLength1,XPhase,Shift1,0);
   if(XMA1_Handle==INVALID_HANDLE) Print("      XMA_Ishimoku 1");
   
//----    XMA_Ishimoku 2
   XMA2_Handle=iCustom(Symbol(),PERIOD_CURRENT,"XMA_Ishimoku",
                  Up_period2,Dn_period2,Up_mode2,Dn_mode2,XMA2_Method,XLength2,XPhase,Shift2,0);
   if(XMA2_Handle==INVALID_HANDLE) Print("      XMA_Ishimoku 2");
   
//----    XMA_Ishimoku 3
   XMA3_Handle=iCustom(Symbol(),PERIOD_CURRENT,"XMA_Ishimoku",
                   Up_period3,Dn_period3,Up_mode3,Dn_mode3,XMA3_Method,XLength3,XPhase,Shift3,0);
   if(XMA3_Handle==INVALID_HANDLE) Print("      XMA_Ishimoku 3");

//----      
   SetIndexBuffer(0,XMA1,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift1);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,StartBars);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(XMA1,true);
   
//----      
   SetIndexBuffer(1,XMA2,INDICATOR_DATA);
//----    2  
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift2);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,StartBars);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(XMA2,true);
   
//----      
   SetIndexBuffer(2,XMA3,INDICATOR_DATA);
//----    3  
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift3);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,StartBars);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(XMA3,true);

//----      
   string shortname="3 Ishimoku XMA";
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);

//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----  
  }
//+------------------------------------------------------------------+ 
//| 3 Ishimoku XMA iteration function                                | 
//+------------------------------------------------------------------+ 
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(BarsCalculated(XMA1_Handle)<rates_total
    || BarsCalculated(XMA2_Handle)<rates_total
    || BarsCalculated(XMA3_Handle)<rates_total
    || StartBars>rates_total) return(RESET);

//----    
   int to_copy;

//----    
   if(prev_calculated>rates_total || prev_calculated<=0)
        to_copy=rates_total-1;
   else to_copy=rates_total-prev_calculated+1;

//----      
   if(CopyBuffer(XMA1_Handle,0,0,to_copy,XMA1)<=0) return(RESET);
   if(CopyBuffer(XMA2_Handle,0,0,to_copy,XMA2)<=0) return(RESET);
   if(CopyBuffer(XMA3_Handle,0,0,to_copy,XMA3)<=0) return(RESET);
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
